/* ****************************************************************************
 *    File Name   : 2817.D  (Electrical Eraser PROM)
 *    Pin num	  : 28-pin	(A0..A10	D0..D7) 
 *    Last Modify Date : 91. 3. 15 
 *
 *    Memory Size : 16K	(7FF)
 *    Vpp	  : 0.0	(Erase: Vpp=12.0)
 *    Vcc	  : 5.0
 *    Dur=1ms	  : AMD	        *2817A (max=10ms)
 *		    CSI		28C17A (max=10ms)
 *		    EXEL	2817A(maximum :10ms)
 *		    GI		28C17A 
 *		    INTEL       *2817A
 *		    NS		9817A	9817
 *		    SEEQ	2817A	5517A(max=10ms)	2817AH(max=2ms)
 *    Dur=500us   : MICROCHIP  2817	28C17A	28C17AF(100us)
 *		    ATMEL	*28HC17	 28C17	(500us) 
 *    Dur=2ms    : SAMSUNG	2817A (min=2ms)	28C17
 * ************************************************************************** */
declaration
   dataunit : byte;
   functions
      Program
      Read
      Verify
      Blank_Check
      Data_Compare
   ;
   Manufacturers
      MICROCHIP      	/*  500us  */
      ATMEL
      AMD		/* 2:1ms  */
      CSI
      EXEL
      GI
      INTEL
      NS
      SEEQ
      SAMSUNG      	/*  9:2ms   */
   ;
   Devices
      D2817A
      D2817AH
      D5517A
      D28C17
      D28C17A
      D28C17AF	/* 100us */
      D9817
      D9817A
      D28HC17
   ;
   chips = RDY, NC1_, A7, A6, A5, A4, A3, A2, A1, A0, D0, D1, D2, GND,
	   D3, D4, D5, D6, D7, CE, A10, OE, NC2_, A9, A8, NC3_, WE, Vcc;
   $v2 = OE;	   
   $v3 = Vcc;
endd

/* -----------------------------------------------------------------------
 * Failf () ---> Fail address setting
 * ----------------------------------------------------------------------- */
int Failf (hwhb, hwlb, lwhb, lwlb, tmp)
int hwhb, hwlb, lwhb, lwlb, tmp;
{
int high, low;

   high = (hwhb << 8) | hwlb;
   low  = (lwhb << 8) | lwlb;

   @Fail high, low, tmp;
}
/* -----------------------------------------------------------------------
 * init () ---> Initial processing
 * ----------------------------------------------------------------------- */
int     init ( vol3 )
voltage  vol3;
{
   @Vout 3	 , vol3;            /* Voltage Source #3 */
   @Out GND      , @G;       /* Ground output */
   @Delay 10	 , @ms;

   @Out D [0..7] , @W;       /* ------------------------ */
   @Out A [0..7] , @W;       /*                          */
   @Out A [8..10], @W;       /*   Initial Direction      */
   @Out CE       , @W;       /*         Of               */
   @Out WE	 , @W;	     /*        Port		 */
   @Out OE       , @W;       /* ------------------------ */
   @Out RDY	 , @W;
   @Out Vcc	 , @W;
   @Out __GANG__[0..3], @W;

   @Out CE	 , @H;
   @Out WE	 , @H;   
   @Out OE	 , @H;
   @Out RDY	 , @H;
   @Out Vcc	 , @H;
   @Out __GANG__[0..3], @H;
   
   @Out Vcc      , @O;       /* Vcc Enable */
   @Delay 100	 , @Ms;
}
/* -----------------------------------------------------------------------
 * InitProcess () ---> Initial Buffer | Voltage source
 * ----------------------------------------------------------------------- */
int InitProcess ()
{
   init ( 5.0 );
}
/* -----------------------------------------------------------------------
 * read () ---> read processing
 * ----------------------------------------------------------------------- */
int read (row)
int	row;
{
int  hwhb, hwlb, lwhb, lwlb;
int  sll, ell, slh, elh;
int  tmp, tmp2;

   lwlb = lwhb = hwhb = hwlb = 0;
   sll = ell = slh = elh = 0;
   tmp = tmp2 = 0;
   
   @Set B_HADDR, B_LADDR;
   @Inc	__B_START__;
   
   @Out D [0..7], @Z;	/* Data Input  */
   
   if (FUNCTION == Read ) 
   {
      @Display 26, row, "Reading...";
      @CheckSumON;
   }
   else if (FUNCTION == Verify)		@Display 26, row, "Verifying...";
   else if (FUNCTION == Blank_Check)	@Display 26, row, "Blank Checking...";
   else 			        @Display 26, row, "Data Comparing...";
   
   for ( hwhb=0 /* S_HWHB */ ; hwhb<=0 /* E_HWHB */; hwhb++ )
   {
      @Display 64, 9, hwhb;
      for ( hwlb=0; hwlb<=0; hwlb++ )
      {
         @Display 66, 9, hwlb;      
      	 if (hwlb == S_HWLB) slh = S_LWHB;
         else                slh = 0;
         if (hwlb == E_HWLB) elh = E_LWHB;
         else                elh = 0xFF;
         
	 for ( lwhb=slh; lwhb<= elh; lwhb++)
         {
	    @Display 68, 9, lwhb;
	    @Out A [8..10], lwhb;   /* Output High word address */
	    
	    if (lwhb == S_LWHB) sll = S_LWLB;
            else                sll = 0;
            if (lwhb == E_LWHB) ell = E_LWLB;
            else                ell = 0xFF;

	    for ( lwlb=sll; lwlb<=ell; lwlb++)
	    {
	       @Out A [0..7], lwlb;    /* Low  byte address output */
	       
	       if (GANG == 0)	@Out CE      	   , @L;
	       else		@Out __GANG__[GANG], @L;
	       
	       @Out OE      , @L;

	       @In  D [0..7], tmp;
	       
	       if (GANG == 0)	@Out CE	    	   , @H;
	       else		@Out __GANG__[GANG], @H;
	       
	       @Out OE	    , @H;

	       if (FUNCTION == Read)          @Load tmp;
	       else if (FUNCTION == Blank_Check)
	       {
		  if (tmp != 0xFF)
		     Failf (hwhb, hwlb, lwhb, lwlb, tmp);
	       }
	       else if (FUNCTION == Verify)
               {
                  @Store tmp2;
                  if (tmp != tmp2) Failf (hwhb, hwlb, lwhb, lwlb, tmp);
	       }
	       else if (FUNCTION == Data_Compare) 
	       {
	       	    @Store	tmp2;
	       	    @Compare	tmp, tmp2;
	       }
	       if (FUNCTION != Blank_Check)	@Inc SPLIT;
            }
	 }
      }
   }
   if 	   (FUNCTION == Read)		@Display 26, row, "Read OK!   ";
   else if (FUNCTION == Verify)		@Display 26, row, "Verification OK!";
   else if (FUNCTION == Blank_Check)	@Display 26, row, "Blank Check OK!  ";
   else 			        @Display 26, row, "Data Comparison OK!";
}
/* --------------------------------------------------------------------
 * program() ---> Control main
 * -------------------------------------------------------------------- */
int program ()
{
int  hwhb, hwlb, lwhb, lwlb;
int  sll, ell, slh, elh;
int  tmp, tmp2, Dur;

   @Set  B_HADDR, B_LADDR;
   @Inc  __B_START__;
   
   lwlb = lwhb = hwhb = hwlb = 0;
   sll = ell = slh = elh = Dur = tmp = tmp2 = 0;
   
   if 	   (MFG == MICROCHIP)	
   {
   	if (DEVICE == D28C17AF)	Dur = 100;
   	else			Dur = 500;
   }
   else if (MFG <= 1)		Dur = 500;
   else if (MFG <= 8)		Dur = 1000;
   else				Dur = 2000;
	
   @Display 26, 6, "Programming...";      
   @Out OE	, @L;   

   for ( hwhb=0 /* S_HWHB */; hwhb<=0 /* E_HWHB */; hwhb++ )
   {
       @Display 64, 9, hwhb;
       for ( hwlb=0 /* S_HWLB */; hwlb<=0 /* E_HWLB */; hwlb++ )
       {
	   @Display 66, 9, hwlb;
	   if (hwlb == S_HWLB) slh = S_LWHB;
           else                slh = 0;
           if (hwlb == E_HWLB) elh = E_LWHB;
           else                elh = 0xFF;
           
           for ( lwhb=slh; lwhb<=elh; lwhb++)
	   {
	       @Display 68, 9, lwhb;
	       @Out A [8..10], lwhb;   /* Output High word address */
	       
	       if (lwhb == S_LWHB) sll = S_LWLB;
               else                sll = 0;
               if (lwhb == E_LWHB) ell = E_LWLB;
               else                ell = 0xFF;

	       for ( lwlb=sll; lwlb<=ell; lwlb++)
	       {
		  @Store tmp;

	          @Out A [0..7]	, lwlb;
	          @Out OE      	, @H;
	          if (GANG == 0)	@Out  CE      	   , @L;  
	          else			@Out __GANG__[GANG], @L;
	          @Out WE	, @L;
	          
	          @Out D [0..7], tmp;
	          
		  if (GANG == 0)	@Out CE     	   , @H;
		  else			@Out __GANG__[GANG], @H;
		  @Out WE      	, @H;
		  @Out OE     	, @L;
		  @Out RDY	, @L;
		  @Delay Dur	, @us;
		  
		  @Out D [0..7]	, @W;	          
		  @Out RDY     	, @H;
		  
		  @Inc	SPLIT;
               }
	   }
       }
   }
   @Display 26, 6, "Program OK!   ";
   FUNCTION = Verify;
   read (7);		/*  Verify  */
}

/* -----------------------------------------------------------------------
 * main () ---> Control main
 * ----------------------------------------------------------------------- */
int main ()
{
   InitProcess();

   if ( FUNCTION == Program ) 	program();
   else if ( FUNCTION == Read )
   {
   	if 	(GANG >= 1 && __B_START__ == 0);
   	else if (GANG == 3 && __B_START__ == 1);
   	else 	read (6);
   }    
   else 			read (6);
}
/* ---------------------------- End of program --------------------------- */ 